﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;    // 追加 ファイル操作で使用

namespace WindowsFormsApplication1
{
    public partial class Flogging : Form
    {
        public uint rpm, air, inj, ign, o2, knock, speed, distance;
        uint rpm_, air_, inj_, ign_, o2_, knock_, speed_;
        public int water_temp, air_temp, oil_temp;
        int water_temp_, air_temp_, oil_temp_;
        public bool logging = false;    // ログをファイルに記録するか
        public bool IsOpen = false;     // ログファイルはオープン中か

        //string filename = @"c:\test.log"; // @を付けると文字列中のエスケープシーケンスを無視する（\を'\'として扱う）改行文字も含めることができる
        string filename = DateTime.Now.ToString("yyyyMMdd")+".log";
        int step = 5;
        Bitmap img = new Bitmap(640, 270);      // グラフを描くところ
        Bitmap label = new Bitmap(200, 270);    // ラベルを描くところ
        Bitmap screen = new Bitmap(640, 270);   // 合成先
        //StreamWriter w;
        //FileStream w;

        public void logenabled(bool a)
        {
            if (a == true)
            {
                File.AppendAllText(filename, "\r\n\r\n" + DateTime.Now.ToString() + "\r\nHHmmss,速度,距離,回転数,吸気量,噴射量,点火時期,O2,ノック,水温,吸気温,油温");
                logging = true;
            }
            else
            {
                logging = false;
            }
        }
        public Flogging()
        {
            InitializeComponent();

            // これは動く
            /*using (StreamWriter sw = File.AppendText(filename))
            {
                sw.WriteLine("This");
                sw.WriteLine("is Extra");
                sw.WriteLine("Text");
            }*/ 

            //File.AppendAllText(filename,"123456789");
            //File.AppendAllText(filename, "abcdefg");
            
            // これは動かない。なぜ？
            /*try
            {
                w = File.AppendText(filename);
                //w = File.Open(filename, FileMode.OpenOrCreate); // ファイルを読み書き可で開く。無ければ作成する。
                IsOpen = true;
            }
            catch
            {
                IsOpen = false;
            }
            
            w.Write("123456");
            w.WriteLine("123456789");
            */
        }

        public void update()
        {
            if (this.Visible == true)   // 表示されている時だけ、表示を更新
            {
                draw();
            }

            // ファイルに記録
            if(logging==true)
            {
                //File.AppendAllText(filename, "\r\n\r\n速度,距離,回転数,吸気量,噴射量,点火時期,O2,ノック,水温,吸気温,油温");
                File.AppendAllText(filename,
                    "\r\n"
                    +DateTime.Now.ToString("HHmmss")
                    + "," + speed.ToString("D")
                    + "," + distance.ToString("D")
                    + "," + rpm.ToString("D")
                    + "," + air.ToString("D")
                    + "," + inj.ToString("D")
                    + "," + ign.ToString("D")
                    + "," + o2.ToString("D")
                    + "," + knock.ToString("D")
                    + "," + water_temp.ToString("D")
                    + "," + air_temp.ToString("D")
                    + "," + oil_temp.ToString("D"));
               //w.Write("\r\n////");
                /*using (StreamWriter w = File.AppendText(filename))
                {
                    w.Write("\r\n////");
 
                    w.Close();
                }*/
            }
        }

        private void draw()
        {
            Graphics sc = Graphics.FromImage(screen);
            Graphics g = Graphics.FromImage(img);
            Graphics gl = Graphics.FromImage(label);
            Font font = new Font("MS UI Gothic", 9, FontStyle.Regular);

            gl.FillRectangle(Brushes.White, 0, 0, 200, 480);    // 白で塗りつぶす
            g.DrawImage(new Bitmap(img), step, 0);// 右にコピー
            
            //g.DrawImage(
            g.FillRectangle(Brushes.White, 0, 0, step, 480);    // 白で塗りつぶす

            g.DrawLine(Pens.LightGray, 0, 0, 0, 480);// 縦線
            g.DrawLine(Pens.Black, 0, 255 - (int)rpm / (9000 / 255), step, 255 - (int)rpm_ / (9000 / 255));
            g.DrawLine(Pens.Brown, 0, air, step, air_);
            g.DrawLine(Pens.Red, 0, 255 - (int)inj / (30000 / 255), step, 255 - (int)inj_ / (30000 / 255));
            g.DrawLine(Pens.Orange, 0, 255 - (int)ign * (255 / 50), step, 255 - (int)ign_ * (255 / 50));
            g.DrawLine(Pens.LightBlue, 0, 255 - o2 / ((float)60 / 255), step, 255 - o2_ / ((float)60 / 255));
            g.DrawLine(Pens.Green, 0, 255 - knock, step, 255 - knock_);
            g.DrawLine(Pens.Blue, 0, 255 - 50 - water_temp, step, 255 - 50 - water_temp_);
            g.DrawLine(Pens.Purple, 0, 255 - 50 - air_temp, step, 255 - 50 - air_temp_);
            g.DrawLine(Pens.Gray, 0, 255 - 50 - oil_temp, step, 255 - 50 - oil_temp_);
            g.DrawLine(Pens.OrangeRed, 0, 255 - speed, step, 255 - speed_);

            gl.DrawString("吸気量 " + air.ToString("D"), font, Brushes.Brown, 0, air);
            gl.DrawString("噴射 " + inj.ToString("D"), font, Brushes.Red, 0, 255 - (int)inj / (30000 / 255));
            gl.DrawString("BTDC " + ign.ToString("D"), font, Brushes.Orange, 0, 255 - (int)ign * (255 / 50));
            gl.DrawString("O2 " + o2.ToString("D"), font, Brushes.LightBlue, 0, 255 - o2 / ((float)60 / 255));
            gl.DrawString("knock " + knock.ToString("D"), font, Brushes.Green, 0, 255 - knock);
            gl.DrawString("水温 " + water_temp.ToString("D"), font, Brushes.Blue, 0, 255 - 50 - water_temp);
            gl.DrawString("吸気温 " + air_temp.ToString("D"), font, Brushes.Purple, 0, 255 - 50 - air_temp);
            gl.DrawString("油温 " + oil_temp.ToString("D"), font, Brushes.Gray, 0, 255 - 50 - oil_temp);
            gl.DrawString(speed.ToString("D")+" km/h", font, Brushes.OrangeRed, 0, 255 - speed);
            gl.DrawString(rpm.ToString("D") + " RPM", font, Brushes.Black, 0, 255 - (int)rpm / (9000 / 255));

            label.MakeTransparent(Color.White);// 白を透明色に指定する
            sc.DrawImage(img, 0, 0);    // グラフをスクリーンバッファに書き込み
            sc.DrawImage(label, 0, 0);  // ラベルをスクリーンバッファに書き込み（白抜き合成）

            pictureBox1.Image = screen;
            g.Dispose();
            gl.Dispose();
            sc.Dispose();
            font.Dispose();

            rpm_ = rpm;
            air_ = air;
            inj_ = inj;
            ign_ = ign;
            o2_ = o2;
            knock_ = knock;
            water_temp_ = water_temp;
            air_temp_ = air_temp;
            oil_temp_ = oil_temp;
            speed_ = speed;
        }

        // クローズボタンが押されたイベント
        private void logging_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;    // 閉じずに
            this.Hide();    // 見えなくする
        }
    }
}
